      FUNCTION HYPME (AN,E)
C              ! HYPERBOLIC MEAN TO ECCENTRIC
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DOUBLE,REAL
      PARAMETER(DOUBLE=1,REAL=0)
C       F(X) = E*SINH(X)-X    F(X) IS BETTER FOR E NEAR 1 AND X NEAR 0
      F(X)=X*(D+E*X*X/6*(1+X*X/20*(1+X*X/42*(1+X*X/72*(1+X*X/110*
     1(1+X*X/168*(1+X*X/210*(1+X*X/272*(1+X*X/342)))))))))
C       DF(X) = DF(X)/DX
      DF(X)=D+E*X*X/2*(1+X*X/12*(1+X*X/30*(1+X*X/56*(1+X*X/90*(1+
     1X*X/132*(1+X*X/182*(1+X*X/240*(1+X*X/306))))))))
      D=ABS(1-E)
      HYPME=AN/D
      IF (D.LE.ABS(AN)) HYPME=CBRT(6*AN)
      IF (ABS(AN).GT.1.) HYPME=SIGN(LOG(1+ABS(2*AN/E)),AN)
      DO 10 I=1,20
          HYPME0=HYPME
          IF (ABS(HYPME0).LT.1.) THEN
              HYPME=HYPME0-(F(HYPME0)-AN)/DF(HYPME0)
          ELSE
              HYPME=HYPME0-(E*SINH(HYPME0)-HYPME0-AN)/(E*COSH(HYPME0)-1)
          ENDIF
          IF (ABS(HYPME0-HYPME).LE.(3.E-8)*ABS(HYPME0)) RETURN
   10 CONTINUE
      CALL ERROR ('HYPME: TOO MANY ITERATIONS')
      RETURN

      END
