
	subroutine cnvrt1(ra1,dec1,lamda1,beta1,iflag)

C converts from RA and Dec to heliocentric coordinates (iflag=1)
C and vice-versa (iflag=-1)
C PDS pg 44 and 46

	integer iflag
	double precision ra1,dec1,lamda1,beta1
	double precision ra,dec,lamda,beta,e,pi,x,y

	pi=3.141592654
C 1980.0 value of obliquity. Correct thing to do ?
	e=23.441884d0
	e=(pi/180.0d0)*e

	if(iflag.eq.1) then

	    ra=(pi/12.0d0)*ra1
	   dec=(pi/180.0d0)*dec1 
	     y=dsin(ra)*dcos(e)+dtan(dec)*dsin(e)
	     x=dcos(ra)
	lamda1=(180.0d0/pi)*datan2(y,x)
             y=dsin(dec)*dcos(e)-dcos(dec)*dsin(e)*dsin(ra)
          beta1=(180.0d0/pi)*dasin(y)

	else
	lamda=lamda1*(pi/180.0d0)
	 beta=beta1*(pi/180.0d0)
	    y=dsin(lamda)*dcos(e)-dtan(beta)*dsin(e)
	    x=dcos(lamda)
	  ra1=(12.0d0/pi)*datan2(y,x)
	if(ra1.le.0.0d0)  ra1=24.0d0+ra1
	    y=dsin(beta)*dcos(e)+dcos(beta)*dsin(e)*dsin(lamda)
	 dec1=(180.0/pi)*dasin(y)

	end if

	return

	end
